#!/usr/bin/perl

require "config.pl";
use CGI;

$query = new CGI();
print $query->header();

$dbh= newdbh();

$q = $query->param('q');
header("FTP Index - Search");

#build querylist
if ($q ne ""){
  @Q = split (/ /,$q);
  $where = "";
  while (scalar(@Q)!=0){
    $where = $where." AND FileName LIKE '%".quotemeta(shift @Q)."%'";
  }
}

#for show all files on server
$id = $query->param('id');
if ($id ne ""){
  $where = " AND A.ServerID=$id";
}

debug("search condition: '$where'");

if ($where ne ""){
  $result = $dbh->selectall_arrayref("SELECT COUNT(*) FROM Files A, Server B
                                        WHERE A.ServerID = B.ServerID
                                      $where");
  $records = $result->[0][0];
  if ($records == 0){
    print ("<B>No results found</B>");
  }else{
    $s = $query->param('s');
    if (!defined($s)) { $s=0 };
    $result = $dbh->selectall_arrayref("SELECT A.ServerID, ServerName, User, Password,
                                               LastConnect, FileName, Date, Size, Port
                                          FROM Server A, Files B
                                         WHERE A.ServerID = B.ServerID
                                         $where
                                         ORDER BY $_sortby
                                         LIMIT $s,$_results ");
    print "<CENTER>$records files found</CENTER>";
    #print tableheader
    print "<TABLE WIDTH=\"100%\" CLASS=\"result_table\">";
    print "<TR>";
    print "<TH></TH>";
    print "<TH>Server</TH>";
    print "<TH>File</TH>";
    print "<TH>Size</TH>";
    print "<TH>Filetime</TH>";
    print "<TH>Last checked</TH>";
    print "</TR>\n";
    
    #print results
    $row=0;
    while (defined($result->[$row][0])){

      $ServerID = $result->[$row][0];
      $Server   = $result->[$row][1];
      $User     = $result->[$row][2];
      $Pass     = $result->[$row][3];
      $LastConn = $result->[$row][4];
      $FullFile = $result->[$row][5];
      $DateTime = $result->[$row][6];
      $Size     = $result->[$row][7];
      $Port     = $result->[$row][8];
      
      $FileUrl = "ftp://$User:$Pass".'@'."$Server:$Port/$FullFile";
      $FileUrl =~ s/anonymous:ano\@nymo.us@//;
      $FileUrl =~ m/(ftp:\/\/.*?\/)(.*\/)?(.*)/;
      $RootUrl = $1;
      $DirUrl  = $1.$2;
      $Dir     = $2;
      $File    = $3;

      #cut path if too long
      if ((length($Dir)+length($File))>$_maxchar){
        $space = $_maxchar-length($File);
        if ($space > 0){
          $Dir = "...".substr($Dir,0-$space);
        }else{
          $Dir = ".../";
        }
      }
 
      print "<TR>";
      if(!$_public){
        print "<TD>
                   <A HREF=\"delserver.cgi?id=$ServerID\"
                      TITLE=\"Delete Server\"
                      CLASS=\"result_del\">
                       DEL
                   </A>
               </TD>";
      }else{
        print "<TD></TD>";
      }
      print "<TD>
                 <A HREF=\"search.cgi?id=$ServerID\"
                    TITLE=\"Show all files at this server\"
                    CLASS=\"result_server\">
                   $Server
                 </A>
              </TD>";
      print "<TD>
                 <A HREF=\"$RootUrl\"
                    TITLE=\"$RootUrl\"
                    CLASS=\"result_root\">/</A>
                 <A HREF=\"$DirUrl\"
                    TITLE=\"$DirUrl\"
                    CLASS=\"result_dir\">$Dir</A>
                 <A HREF=\"$FileUrl\"
                    TITLE=\"$FileUrl\"
                    CLASS=\"result_file\">$File</A>
             </TD>";
      printf ("<TD>
                 <SPAN CLASS=\"result_size\">%.2fmb</SPAN>
               </TD>",$Size/1048576);
      print "<TD>
                <SPAN CLASS=\"result_time\">$DateTime</SPAN>
            </TD>";
      print "<TD>
                <SPAN CLASS=\"result_time\">$LastConn</SPAN>
             </TD>";
      print "</TR>\n";
      
      $row++;
    }
    print "</TABLE>";

    #Print pagelinks
    print "<HR SIZE=1>";
    if ($s-$_results >= 0) {
      print "<A HREF=\"search.cgi?q=$q&id=".$id."&s=".($s-$_results)."\"
              CLASS=\"page_prev\" TITLE=\"Previous Page\"> &lt;&lt; </A>";
    }
    for ($i=0; $i<= int($records/$_results); $i++){
      if ($i*$_results == $s){
        print "<SPAN CLASS=\"page_actual\"> ".
	         ($i+1).
	      " </SPAN>";
      }else{
        print "<A HREF=\"search.cgi?q=$q&id=".$id."&s=".($i*$_results)."\"
	        CLASS=\"page_all\" TITLE=\"Page ".($i+1)."\"> ".($i+1)." </A>"; 
      }
    }
    if ($s+$_results <= $records) {
      print "<A HREF=\"search.cgi?q=$q&id=".$id."&s=".($s+$_results)."\"
              CLASS=\"page_next\" TITLE=\"Next page\"> &gt;&gt; </A>";
    }
  }
}
print "</BODY>";
print "</HTML>";

$dbh->disconnect;
