#!/usr/bin/perl

use CGI;
require "config.pl";

if ($_public){exit;} #don't show this cgi on a public server

$query = new CGI();
print $query->header();

$dbh = newdbh();

header("FTP Index - Add multiple Servers");

print <<ENDofHTML;

<TABLE WIDTH="100%">
<TR>
<TD ALIGN="center">
    <FORM ACTION="massadd.cgi" METHOD="POST">
    Add one server per line<BR>
    <TEXTAREA NAME="Servers" ROWS="10" COLS="50"></TEXTAREA><BR>
    <INPUT TYPE="submit" VALUE="Add Servers">
    </FORM>
</TD>
<TD>
   Use the following format for adding servers:<BR>
   <code>
      [ftp://][&lt;user&gt;:&lt;password&gt;\@]&lt;ftpserver&gt;[:port]
   </code><BR>
   all trailing path- or filenames are removed<BR>

   <HR SIZE="1">
   <P>
   <FORM ACTION="massadd.cgi" METHOD="GET">
     <INPUT TYPE="hidden" NAME="runindexer" VALUE="1">
     This will start the indexer in the background:
     <INPUT TYPE="submit" VALUE="run indexer right now"><BR>
     This is not recommended instead the index should be run from a daily cron-job
   </FORM>
   </P>
   
</TD>
</TR>
</TABLE>

<HR SIZE="1">
ENDofHTML
#'

$Servers=$query->param('Servers');
if ($Servers){
#Get Servers in Array
  @aryServers = split("\n",$Servers);
#Handle 'em line by line:
  while(scalar(@aryServers)){
    $server=shift(@aryServers);

    #Replace weird stuff by blanks
    $server =~ tr/\n\r\f\t/    /s;
    #Remove protocol, trailing paths and blanks
    $server =~ s/ftp:\/\///i;
    $server =~ s/\/.*$//;
    $server =~ s/ +$//;
    #get port if given
    $server =~ s/:([0-9]+)$//;
    $port = "$1";
   
    #Remove trailing whitespaces
    $server =~ s/\s*$//;
   
    #Skip empty servers:
    if ($server eq "") {next;}
   
    #get bound for userinfos
    $a = rindex($server,'@');
    $c = rindex($server,':');
    
    #Check for Userinfo
    $user=undef;
    $pass=undef;
    if ($a != -1 ){
      #okay there are userinfos...
      if ($c != -1){
        #...with password
	$pass = substr($server,$c+1,$a-$c-1);
	$user = substr($server,0,$c);
      }else{
        #...with no password
        $pass = "";
	$user = substr($server,0,$a);
      }
    }
    #Remove Userinfo:
    $server =~ s/^.*@//g ;
    
    #Set up standard port
    if ($port eq ""){
        $port=21;
    }

    ###Do Databasestuff###
    &debug("massadd.cgi parsed-> Server:'$server' User:'$user' Pass:'$pass' Port:'$port'");
    #Skip known servers
    $result = $dbh->selectall_arrayref("SELECT COUNT(*) FROM Server WHERE ServerName='$server'");
    if ($result->[0][0] > 0) {
      print "$server <B>already in database</B><BR>";
      next;
    }

    if ((defined($user)) && (defined($pass))){
        $sql = "INSERT INTO Server (ServerName, User, Password, Port) VALUES ('$server','$user','$pass',$port)";
    }else{
        $sql = "INSERT INTO Server (ServerName, Port) VALUES ('$server', $port)";
    }
    if ( ($dbh->do($sql)) == 0E0 ) { 
      print "$server <B>Insert failed</B>".($dbh->errstr)."<BR>";
    }else{
      print "$server <B>added</B><BR>";
    }
  }
}


$runindexer=$query->param('runindexer');
if ($runindexer){
  system('./indexer.pl &');
  print "<H3>Indexer started in background</H3>";
  print "Press your browsers <code>stop<code> button to stop loading this page now. The indexer will continue to run in background.";
}

print "</BODY>";
print "</HTML>";
$dbh->disconnect;
