#!/usr/bin/perl

use CGI;
use LWP::Simple;
require "config.pl";

$query = new CGI();
print $query->header();

header("FTP Index - Get FTP adresses from Websites");

print <<ENDofHTML;
   
<P>
Use this form to give a website that contains links to ftp servers.
The script will fetch the site and extract all ftp-links.
</P>

<FORM ACTION="slurp.cgi" METHOD="POST">
  <INPUT TYPE="text" size="50" NAME="url" VALUE="http://">
  <INPUT TYPE="submit" VALUE="Get Servers">
</FORM>

ENDofHTML
#'

$url=$query->param('url');
if (defined ($url)){
  #Replace weird stuff by blanks
  $url =~ tr/\n\r\f\t/    /s;
  #Remove trailing blanks
  $url =~ s/ +$//;

  $content = get($url);
  if (!defined($content)){
    print "<P><B>Fetching failed</B><BR>";
    print "<A HREF=\"$url\" TARGET=\"_blank\">$url</A></P>";
  }else{
    #Search for FTPs
    while ($content =~ m/([^\d\w.~\-@=:])*(ftp:\/\/[\d\w.~\-@=:]*)/sg){
      push (@servers,$2);
    }
    #Print
    if (! scalar(@servers)){
      print '<P><B>No servers found</B><BR>';
      print "<A HREF=\"$url\" TARGET=\"_blank\">$url</A></P>";
    }else{
      print '<P><B>Server(s) found!</B><BR>';
      print "<A HREF=\"$url\" TARGET=\"_blank\">$url</A></P>";
      print '<FORM ACTION="massadd.cgi" METHOD="POST">';
      print '<TEXTAREA NAME="Servers" ROWS="10" COLS="50">';
      @helphash{@servers} = ();	#This makes the list unique!
      @servers = sort keys %helphash;
      foreach (@servers){
        print "$_\n";
      }
      print '</TEXTAREA>';
      if (!$_public){
        #don't show this button on a public server
        print '<P><INPUT TYPE="submit" VALUE="Add Servers"> ';
        print 'Press this button to add the servers to the database</P>';
      }
      print '</FORM>';
    }
  }
}

print "</BODY>";
print "</HTML>";
